<template>
    <a-spin :spinning="isLoaded">
        <div class="layout-center">
            <div class="layout-border" style="background: rgb(255, 255, 255); padding: 24px">
                <a-typography-title :level="3" :style="{ marginBottom: 42 }">Reset Password</a-typography-title>
                <a-form
                    :label-col="{ style: { width: '35%', textAlign: 'left' } }"
                    :wrapper-col="{ style: { width: '40%' } }"
                    :model="formState"
                    :rules="rules"
                    name="normal_login"
                    class="login-form"
                    @finish="onFinish"
                    @finishFailed="onFinishFailed"
                    :style="{ width: '400px' }"
                >
                    <!-- <a-form-item hidden label="Email" name="email" :rules="[
                            { required: true, message: 'Please input your email!' },
                            { type: 'email', message: 'Email Invalid' },
                        ]">
                        <a-input placeholder="input your email" v-model:value="formState.email">
                        </a-input>
                    </a-form-item> -->
                    <a-form-item label="Password" name="password" :rules="[{ required: true, message: 'Please input your password!' }]">
                        <a-input-password v-model:value="formState.password" type="password" autocomplete="off" />
                    </a-form-item>

                    <a-form-item label="Password Confirm" name="password_confirmation">
                        <a-input-password v-model:value="formState.password_confirmation" type="password" autocomplete="off" />
                    </a-form-item>

                    <a-typography-text type="danger" v-if="errors">*{{ errors }}</a-typography-text>

                    <div :style="{ display: 'flex', justifyContent: 'center', alignItems: 'flex-start', marginTop: '36px' }">
                        <a-form-item>
                            <a-button type="primary" html-type="submit" class="login-form-button"> Send request </a-button>
                        </a-form-item>
                    </div>
                </a-form>
            </div>
        </div>
    </a-spin>
</template>
<script lang="ts" setup>
import { reactive, onMounted } from "vue";
import { message } from "ant-design-vue";
import type { Rule } from "ant-design-vue/es/form";

const route = useRoute();

const authStore = useAuthStore();
const userStore = useUserStore();
const { user, isLoaded } = storeToRefs(userStore);

let token = route.params.token as string;
let errors = ref<string | null>(null);


interface FormState {
    token: string;
    password: string;
    password_confirmation: string;
}

const formState = reactive<FormState>({
    token: "",
    password: "",
    password_confirmation: "",
});

const validateConfirmPassword = async (_rule: Rule, value: string) => {
    if (value === "") {
        return Promise.reject("Please input the password confirmation!");
    } else if (value !== formState.password) {
        return Promise.reject("The passwords confirm don't match!");
    }
    return Promise.resolve();
};


const rules: Record<string, Rule[]> = {
    password_confirmation: [{ required: true, validator: validateConfirmPassword, trigger: "change" }],
};

const onFinish = async (values: any) => {
    errors.value = null;
    isLoaded.value = true;
    try {
        await authStore.resetPassword({ token: token, password: values.password, password_confirmation: values.password_confirmation});
        message.success("Password reset successfully! Please login.");
        navigateTo("/login");
    } catch (error: any) {
        errors.value = error.response.data.message;
    } finally {
        isLoaded.value = false;
    }
    
};

const onFinishFailed = () => {
    console.log("onFinishFailed");
};

onMounted(async () => {
    isLoaded.value = true;
    try {
       await authStore.verifyToken(token);
    } catch (error: any) {
        message.error(error.response.data.message);
        navigateTo("/login");
    } finally {
        isLoaded.value = false;
    }
});
</script>

<style scoped>
.layout-center {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
}
</style>
